/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the designer application of the Qt Toolkit.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
**   information about Qt Commercial License Agreements.
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "specialeditorsupport.h"
#include "defaultspecialeditor.h"

// Sdk
#include <abstractformeditor.h>
#include <qextensionmanager.h>

SpecialEditorSupport::SpecialEditorSupport(AbstractFormEditor *core)
    : QObject(core),
      m_core(core)
{
    m_factory = new QDesignerSpecialEditorFactory(core->extensionManager());
    core->extensionManager()->registerExtensions(m_factory, Q_TYPEID(ISpecialEditor));
}

SpecialEditorSupport::~SpecialEditorSupport()
{
//    m_core->extensionManager()->unregisterExtensions(m_factory, Q_TYPEID(ISpecialEditor));
}
